#include <iostream>
#include <thread>
#include <unistd.h>

void (*fnSimpleCallback)(int i);

void call_from_thread()
{
    std::cout << "sleeping for 5 sec ... " << std::flush ;
    usleep(5000000);
    std::cout << " ... after sleep trying to callback from new thread .. " << (void *)fnSimpleCallback << std::endl;

    if (nullptr != fnSimpleCallback)
        fnSimpleCallback(2); // does nothing
}

extern "C" void StartTestThread()
{
    std::thread thread(call_from_thread);
    thread.detach();
}

extern "C" void SetSimpleCallback(void* cb)
{
    fnSimpleCallback = (void (*)(int i))cb;
    fnSimpleCallback(1);
}
